FLAC 1.4.2 Free Lossless Audio Codec

Classes | Typedefs | Enumerations | Enumerator | Functions | Variables
FLAC/stream_decoder.h: stream decoder interface
FLAC C API » FLAC/ *_decoder.h: decoder interfaces

## Classes
struct | FLAC__StreamDecoder

## Typedefs
typedef FLAC__StreamDecoderReadStatus(* | FLAC__StreamDecoderReadCallback) (const FLAC__StreamDecoder *decoder, FLAC__byte buffer[], size_t *bytes, void *client_data)
typedef FLAC__StreamDecoderSeekStatus(* | FLAC__StreamDecoderSeekCallback) (const FLAC__StreamDecoder *decoder, FLAC__uint64 absolute_byte_offset, void *client_data)
typedef FLAC__StreamDecoderTellStatus(* | FLAC__StreamDecoderTellCallback) (const FLAC__StreamDecoder *decoder, FLAC__uint64 *absolute_byte_offset, void *client_data)
typedef FLAC__StreamDecoderLengthStatus(* | FLAC__StreamDecoderLengthCallback) (const FLAC__StreamDecoder *decoder, FLAC__uint64 *stream_length, void *client_data)
typedef FLAC__bool(* | FLAC__StreamDecoderEofCallback) (const FLAC__StreamDecoder *decoder, void *client_data)
typedef FLAC__StreamDecoderWriteStatus(* | FLAC__StreamDecoderWriteCallback) (const FLAC__StreamDecoder *decoder, const FLAC__Frame *frame, const FLAC__int32 *const buffer[], void *client_data)
typedef void(* | FLAC__StreamDecoderMetadataCallback) (const FLAC__StreamDecoder *decoder, const FLAC__StreamMetadata *metadata, void *client_data)
typedef void(* | FLAC__StreamDecoderErrorCallback) (const FLAC__StreamDecoder *decoder, FLAC__StreamDecoderErrorStatus status, void *client_data)

## Enumerations
enum | FLAC__StreamDecoderState { FLAC__STREAM_DECODER_SEARCH_FOR_METADATA = 0 , FLAC__STREAM_DECODER_READ_METADATA , FLAC__STREAM_DECODER_SEARCH_FOR_FRAME_SYNC , FLAC__STREAM_DECODER_READ_FRAME , FLAC__STREAM_DECODER_END_OF_STREAM , FLAC__STREAM_DECODER_OGG_ERROR , FLAC__STREAM_DECODER_SEEK_ERROR , FLAC__STREAM_DECODER_ABORTED , FLAC__STREAM_DECODER_MEMORY_ALLOCATION_ERROR , FLAC__STREAM_DECODER_UNINITIALIZED }
enum | FLAC__StreamDecoderInitStatus { FLAC__STREAM_DECODER_INIT_STATUS_OK = 0 , FLAC__STREAM_DECODER_INIT_STATUS_UNSUPPORTED_CONTAINER , FLAC__STREAM_DECODER_INIT_STATUS_INVALID_CALLBACKS , FLAC__STREAM_DECODER_INIT_STATUS_MEMORY_ALLOCATION_ERROR , FLAC__STREAM_DECODER_INIT_STATUS_ERROR_OPENING_FILE , FLAC__STREAM_DECODER_INIT_STATUS_ALREADY_INITIALIZED }
enum | FLAC__StreamDecoderReadStatus { FLAC__STREAM_DECODER_READ_STATUS_CONTINUE , FLAC__STREAM_DECODER_READ_STATUS_END_OF_STREAM , FLAC__STREAM_DECODER_READ_STATUS_ABORT }
enum | FLAC__StreamDecoderSeekStatus { FLAC__STREAM_DECODER_SEEK_STATUS_OK , FLAC__STREAM_DECODER_SEEK_STATUS_ERROR , FLAC__STREAM_DECODER_SEEK_STATUS_UNSUPPORTED }
enum | FLAC__StreamDecoderTellStatus { FLAC__STREAM_DECODER_TELL_STATUS_OK , FLAC__STREAM_DECODER_TELL_STATUS_ERROR , FLAC__STREAM_DECODER_TELL_STATUS_UNSUPPORTED }
enum | FLAC__StreamDecoderLengthStatus { FLAC__STREAM_DECODER_LENGTH_STATUS_OK , FLAC__STREAM_DECODER_LENGTH_STATUS_ERROR , FLAC__STREAM_DECODER_LENGTH_STATUS_UNSUPPORTED }
enum | FLAC__StreamDecoderWriteStatus { FLAC__STREAM_DECODER_WRITE_STATUS_CONTINUE , FLAC__STREAM_DECODER_WRITE_STATUS_ABORT }
enum | FLAC__StreamDecoderErrorStatus { FLAC__STREAM_DECODER_ERROR_STATUS_LOST_SYNC , FLAC__STREAM_DECODER_ERROR_STATUS_BAD_HEADER , FLAC__STREAM_DECODER_ERROR_STATUS_FRAME_CRC_MISMATCH , FLAC__STREAM_DECODER_ERROR_STATUS_UNPARSEABLE_STREAM , FLAC__STREAM_DECODER_ERROR_STATUS_BAD_METADATA }

## Functions
FLAC__StreamDecoder * | FLAC__stream_decoder_new (void)
void | FLAC__stream_decoder_delete (FLAC__StreamDecoder *decoder)
FLAC__bool | FLAC__stream_decoder_set_ogg_serial_number (FLAC__StreamDecoder *decoder, long serial_number)
FLAC__bool | FLAC__stream_decoder_set_md5_checking (FLAC__StreamDecoder *decoder, FLAC__bool value)
FLAC__bool | FLAC__stream_decoder_set_metadata_respond (FLAC__StreamDecoder *decoder, FLAC__MetadataType type)
FLAC__bool | FLAC__stream_decoder_set_metadata_respond_application (FLAC__StreamDecoder *decoder, const FLAC__byte id[4])
FLAC__bool | FLAC__stream_decoder_set_metadata_respond_all (FLAC__StreamDecoder *decoder)
FLAC__bool | FLAC__stream_decoder_set_metadata_ignore (FLAC__StreamDecoder *decoder, FLAC__MetadataType type)
FLAC__bool | FLAC__stream_decoder_set_metadata_ignore_application (FLAC__StreamDecoder *decoder, const FLAC__byte id[4])
FLAC__bool | FLAC__stream_decoder_set_metadata_ignore_all (FLAC__StreamDecoder *decoder)
FLAC__StreamDecoderState | FLAC__stream_decoder_get_state (const FLAC__StreamDecoder *decoder)
const char * | FLAC__stream_decoder_get_resolved_state_string (const FLAC__StreamDecoder *decoder)
FLAC__bool | FLAC__stream_decoder_get_md5_checking (const FLAC__StreamDecoder *decoder)
FLAC__uint64 | FLAC__stream_decoder_get_total_samples (const FLAC__StreamDecoder *decoder)
uint32_t | FLAC__stream_decoder_get_channels (const FLAC__StreamDecoder *decoder)
FLAC__ChannelAssignment | FLAC__stream_decoder_get_channel_assignment (const FLAC__StreamDecoder *decoder)
uint32_t | FLAC__stream_decoder_get_bits_per_sample (const FLAC__StreamDecoder *decoder)
uint32_t | FLAC__stream_decoder_get_sample_rate (const FLAC__StreamDecoder *decoder)
uint32_t | FLAC__stream_decoder_get_blocksize (const FLAC__StreamDecoder *decoder)
FLAC__bool | FLAC__stream_decoder_get_decode_position (const FLAC__StreamDecoder *decoder, FLAC__uint64 *position)
const void * | FLAC__stream_decoder_get_client_data (FLAC__StreamDecoder *decoder)
FLAC__StreamDecoderInitStatus | FLAC__stream_decoder_init_stream (FLAC__StreamDecoder *decoder, FLAC__StreamDecoderReadCallback read_callback, FLAC__StreamDecoderSeekCallback seek_callback, FLAC__StreamDecoderTellCallback tell_callback, FLAC__StreamDecoderLengthCallback length_callback, FLAC__StreamDecoderEofCallback eof_callback, FLAC__StreamDecoderWriteCallback write_callback, FLAC__StreamDecoderMetadataCallback metadata_callback, FLAC__StreamDecoderErrorCallback error_callback, void *client_data)
FLAC__StreamDecoderInitStatus | FLAC__stream_decoder_init_ogg_stream (FLAC__StreamDecoder *decoder, FLAC__StreamDecoderReadCallback read_callback, FLAC__StreamDecoderSeekCallback seek_callback, FLAC__StreamDecoderTellCallback tell_callback, FLAC__StreamDecoderLengthCallback length_callback, FLAC__StreamDecoderEofCallback eof_callback, FLAC__StreamDecoderWriteCallback write_callback, FLAC__StreamDecoderMetadataCallback metadata_callback, FLAC__StreamDecoderErrorCallback error_callback, void *client_data)
FLAC__StreamDecoderInitStatus | FLAC__stream_decoder_init_FILE (FLAC__StreamDecoder *decoder, FILE *file, FLAC__StreamDecoderWriteCallback write_callback, FLAC__StreamDecoderMetadataCallback metadata_callback, FLAC__StreamDecoderErrorCallback error_callback, void *client_data)
FLAC__StreamDecoderInitStatus | FLAC__stream_decoder_init_ogg_FILE (FLAC__StreamDecoder *decoder, FILE *file, FLAC__StreamDecoderWriteCallback write_callback, FLAC__StreamDecoderMetadataCallback metadata_callback, FLAC__StreamDecoderErrorCallback error_callback, void *client_data)
FLAC__StreamDecoderInitStatus | FLAC__stream_decoder_init_file (FLAC__StreamDecoder *decoder, const char *filename, FLAC__StreamDecoderWriteCallback write_callback, FLAC__StreamDecoderMetadataCallback metadata_callback, FLAC__StreamDecoderErrorCallback error_callback, void *client_data)
FLAC__StreamDecoderInitStatus | FLAC__stream_decoder_init_ogg_file (FLAC__StreamDecoder *decoder, const char *filename, FLAC__StreamDecoderWriteCallback write_callback, FLAC__StreamDecoderMetadataCallback metadata_callback, FLAC__StreamDecoderErrorCallback error_callback, void *client_data)
FLAC__bool | FLAC__stream_decoder_finish (FLAC__StreamDecoder *decoder)
FLAC__bool | FLAC__stream_decoder_flush (FLAC__StreamDecoder *decoder)
FLAC__bool | FLAC__stream_decoder_reset (FLAC__StreamDecoder *decoder)
FLAC__bool | FLAC__stream_decoder_process_single (FLAC__StreamDecoder *decoder)
FLAC__bool | FLAC__stream_decoder_process_until_end_of_metadata (FLAC__StreamDecoder *decoder)
FLAC__bool | FLAC__stream_decoder_process_until_end_of_stream (FLAC__StreamDecoder *decoder)
FLAC__bool | FLAC__stream_decoder_skip_single_frame (FLAC__StreamDecoder *decoder)
FLAC__bool | FLAC__stream_decoder_seek_absolute (FLAC__StreamDecoder *decoder, FLAC__uint64 sample)

## Variables
const char *const | FLAC__StreamDecoderStateString []
const char *const | FLAC__StreamDecoderInitStatusString []
const char *const | FLAC__StreamDecoderReadStatusString []
const char *const | FLAC__StreamDecoderSeekStatusString []
const char *const | FLAC__StreamDecoderTellStatusString []
const char *const | FLAC__StreamDecoderLengthStatusString []
const char *const | FLAC__StreamDecoderWriteStatusString []
const char *const | FLAC__StreamDecoderErrorStatusString []
struct FLAC__StreamDecoderProtected * | FLAC__StreamDecoder::protected_
struct FLAC__StreamDecoderPrivate * | FLAC__StreamDecoder::private_

## Detailed Description

This module contains the functions which implement the stream decoder.

The stream decoder can decode native FLAC, and optionally Ogg FLAC (check FLAC_API_SUPPORTS_OGG_FLAC) streams and files.

The basic usage of this decoder is as follows:

- The program creates an instance of a decoder using FLAC__stream_decoder_new().
- The program overrides the default settings using FLAC__stream_decoder_set_*() functions.
- The program initializes the instance to validate the settings and prepare for decoding using
  - FLAC__stream_decoder_init_stream() or FLAC__stream_decoder_init_FILE() or FLAC__stream_decoder_init_file() for native FLAC,
  - FLAC__stream_decoder_init_ogg_stream() or FLAC__stream_decoder_init_ogg_FILE() or FLAC__stream_decoder_init_ogg_file() for Ogg FLAC
- The program calls the FLAC__stream_decoder_process_*() functions to decode data, which subsequently calls the callbacks.
- The program finishes the decoding with FLAC__stream_decoder_finish(), which flushes the input and output and resets the decoder to the uninitialized state.
- The instance may be used again or deleted with FLAC__stream_decoder_delete().

In more detail, the program will create a new instance by calling FLAC__stream_decoder_new(), then call FLAC__stream_decoder_set_*() functions to override the default decoder options, and call one of the FLAC__stream_decoder_init_*() functions.

There are three initialization functions for native FLAC, one for setting up the decoder to decode FLAC data from the client via callbacks, and two for decoding directly from a FLAC file.

For decoding via callbacks, use FLAC__stream_decoder_init_stream(). You must also supply several callbacks for handling I/O. Some (like seeking) are optional, depending on the capabilities of the input.

For decoding directly from a file, use FLAC__stream_decoder_init_FILE() or FLAC__stream_decoder_init_file(). Then you must only supply an open `FILE*` or filename and fewer callbacks; the decoder will handle the other callbacks internally.

There are three similarly-named init functions for decoding from Ogg FLAC streams. Check `FLAC_API_SUPPORTS_OGG_FLAC` to find out if the library has been built with Ogg support.

Once the decoder is initialized, your program will call one of several functions to start the decoding process:

- FLAC__stream_decoder_process_single() - Tells the decoder to process at most one metadata block or audio frame and return, calling either the metadata callback or write callback, respectively, once. If the decoder loses sync it will return with only the error callback being called.
- FLAC__stream_decoder_process_until_end_of_metadata() - Tells the decoder to process the stream from the current location and stop upon reaching the first audio frame. The client will get one metadata, write, or error callback per metadata block, audio frame, or sync error, respectively.
- FLAC__stream_decoder_process_until_end_of_stream() - Tells the decoder to process the stream from the current location until the read callback returns FLAC__STREAM_DECODER_READ_STATUS_END_OF_STREAM or FLAC__STREAM_DECODER_READ_STATUS_ABORT. The client will get one metadata, write, or error callback per metadata block, audio frame, or sync error, respectively.

When the decoder has finished decoding (normally or through an abort), the instance is finished by calling FLAC__stream_decoder_finish(), which ensures the decoder is in the correct state and frees memory. Then the instance may be deleted with FLAC__stream_decoder_delete() or initialized again to decode another stream.

Seeking is exposed through the FLAC__stream_decoder_seek_absolute() method. At any point after the stream decoder has been initialized, the client can call this function to seek to an exact sample within the stream. Subsequently, the first time the write callback is called it will be passed a (possibly partial) block starting at that sample.

If the client cannot seek via the callback interface provided, but still has another way of seeking, it can flush the decoder using FLAC__stream_decoder_flush() and start feeding data from the new position through the read callback.

The stream decoder also provides MD5 signature checking. If this is turned on before initialization, FLAC__stream_decoder_finish() will report when the decoded MD5 signature does not match the one stored in the STREAMINFO block. MD5 checking is automatically turned off (until the next FLAC__stream_decoder_reset()) if there is no signature in the STREAMINFO block or when a seek is attempted.

The FLAC__stream_decoder_set_metadata_*() functions deserve special attention. By default, the decoder only calls the metadata_callback for the STREAMINFO block. These functions allow you to tell the decoder explicitly which blocks to parse and return via the metadata_callback and/or which to skip. Use a FLAC__stream_decoder_set_metadata_respond_all(), FLAC__stream_decoder_set_metadata_ignore() ... or FLAC__stream_decoder_set_metadata_ignore_all(), FLAC__stream_decoder_set_metadata_respond() ... sequence to exactly specify which blocks to return. Remember that metadata blocks can potentially be big (for example, cover art) so filtering out the ones you don't use can reduce the memory requirements of the decoder. Also note the special forms FLAC__stream_decoder_set_metadata_respond_application(id) and FLAC__stream_decoder_set_metadata_ignore_application(id) for filtering APPLICATION blocks based on the application ID.

STREAMINFO and SEEKTABLE blocks are always parsed and used internally, but they still can legally be filtered from the metadata_callback.

Note
  The "set" functions may only be called when the decoder is in the state FLAC__STREAM_DECODER_UNINITIALIZED, i.e. after FLAC__stream_decoder_new() or FLAC__stream_decoder_finish(), but before FLAC__stream_decoder_init_*(). If this is the case they will return `true`, otherwise `false`.
  FLAC__stream_decoder_finish() resets all settings to the constructor defaults, including the callbacks.

## Typedef Documentation

## ◆ FLAC__StreamDecoderReadCallback

typedef FLAC__StreamDecoderReadStatus(* FLAC__StreamDecoderReadCallback) (const FLAC__StreamDecoder *decoder, FLAC__byte buffer[], size_t *bytes, void *client_data)

Signature for the read callback.

A function pointer matching this signature must be passed to FLAC__stream_decoder_init*_stream(). The supplied function will be called when the decoder needs more input data. The address of the buffer to be filled is supplied, along with the number of bytes the buffer can hold. The callback may choose to supply less data and modify the byte count but must be careful not to overflow the buffer. The callback then returns a status code chosen from FLAC__StreamDecoderReadStatus.

Here is an example of a read callback for stdio streams:

FLAC__StreamDecoderReadStatus read_cb(const FLAC__StreamDecoder *decoder, FLAC__byte buffer[], size_t *bytes, void *client_data)
{
FILE *file = ((MyClientData*)client_data)->file;
if(*bytes > 0) {
*bytes = fread(buffer, sizeof(FLAC__byte), *bytes, file);
if(ferror(file))
return FLAC__STREAM_DECODER_READ_STATUS_ABORT;
else if(*bytes == 0)
return FLAC__STREAM_DECODER_READ_STATUS_END_OF_STREAM;
else
return FLAC__STREAM_DECODER_READ_STATUS_CONTINUE;
}
else
return FLAC__STREAM_DECODER_READ_STATUS_ABORT;
}
FLAC__StreamDecoderReadStatus
FLAC__StreamDecoderReadStatus
Definition: stream_decoder.h:294
FLAC__STREAM_DECODER_READ_STATUS_END_OF_STREAM
@ FLAC__STREAM_DECODER_READ_STATUS_END_OF_STREAM
Definition: stream_decoder.h:299
FLAC__STREAM_DECODER_READ_STATUS_ABORT
@ FLAC__STREAM_DECODER_READ_STATUS_ABORT
Definition: stream_decoder.h:310
FLAC__STREAM_DECODER_READ_STATUS_CONTINUE
@ FLAC__STREAM_DECODER_READ_STATUS_CONTINUE
Definition: stream_decoder.h:296
FLAC__StreamDecoder
Definition: stream_decoder.h:470

Note
  In general, FLAC__StreamDecoder functions which change the state should not be called on the decoder while in the callback.

Parameters

  decoder | The decoder instance calling the callback.
  buffer | A pointer to a location for the callee to store data to be decoded.
  bytes | A pointer to the size of the buffer. On entry to the callback, it contains the maximum number of bytes that may be stored in buffer. The callee must set it to the actual number of bytes stored (0 in case of error or end-of-stream) before returning.
  client_data | The callee's client data set through FLAC__stream_decoder_init_*().

Return values

  FLAC__StreamDecoderReadStatus | The callee's return status. Note that the callback should return `FLAC__STREAM_DECODER_READ_STATUS_END_OF_STREAM` if and only if zero bytes were read and there is no more data to be read.

## ◆ FLAC__StreamDecoderSeekCallback

typedef FLAC__StreamDecoderSeekStatus(* FLAC__StreamDecoderSeekCallback) (const FLAC__StreamDecoder *decoder, FLAC__uint64 absolute_byte_offset, void *client_data)

Signature for the seek callback.

A function pointer matching this signature may be passed to FLAC__stream_decoder_init*_stream(). The supplied function will be called when the decoder needs to seek the input stream. The decoder will pass the absolute byte offset to seek to, 0 meaning the beginning of the stream.

Here is an example of a seek callback for stdio streams:

FLAC__StreamDecoderSeekStatus seek_cb(const FLAC__StreamDecoder *decoder, FLAC__uint64 absolute_byte_offset, void *client_data)
{
FILE *file = ((MyClientData*)client_data)->file;
if(file == stdin)
return FLAC__STREAM_DECODER_SEEK_STATUS_UNSUPPORTED;
else if(fseeko(file, (off_t)absolute_byte_offset, SEEK_SET) < 0)
return FLAC__STREAM_DECODER_SEEK_STATUS_ERROR;
else
return FLAC__STREAM_DECODER_SEEK_STATUS_OK;
}
FLAC__StreamDecoderSeekStatus
FLAC__StreamDecoderSeekStatus
Definition: stream_decoder.h:325
FLAC__STREAM_DECODER_SEEK_STATUS_UNSUPPORTED
@ FLAC__STREAM_DECODER_SEEK_STATUS_UNSUPPORTED
Definition: stream_decoder.h:333
FLAC__STREAM_DECODER_SEEK_STATUS_ERROR
@ FLAC__STREAM_DECODER_SEEK_STATUS_ERROR
Definition: stream_decoder.h:330
FLAC__STREAM_DECODER_SEEK_STATUS_OK
@ FLAC__STREAM_DECODER_SEEK_STATUS_OK
Definition: stream_decoder.h:327

Note
  In general, FLAC__StreamDecoder functions which change the state should not be called on the decoder while in the callback.

Parameters

  decoder | The decoder instance calling the callback.
  absolute_byte_offset | The offset from the beginning of the stream to seek to.
  client_data | The callee's client data set through FLAC__stream_decoder_init_*().

Return values

  FLAC__StreamDecoderSeekStatus | The callee's return status.

## ◆ FLAC__StreamDecoderTellCallback

typedef FLAC__StreamDecoderTellStatus(* FLAC__StreamDecoderTellCallback) (const FLAC__StreamDecoder *decoder, FLAC__uint64 *absolute_byte_offset, void *client_data)

Signature for the tell callback.

A function pointer matching this signature may be passed to FLAC__stream_decoder_init*_stream(). The supplied function will be called when the decoder wants to know the current position of the stream. The callback should return the byte offset from the beginning of the stream.

Here is an example of a tell callback for stdio streams:

FLAC__StreamDecoderTellStatus tell_cb(const FLAC__StreamDecoder *decoder, FLAC__uint64 *absolute_byte_offset, void *client_data)
{
FILE *file = ((MyClientData*)client_data)->file;
off_t pos;
if(file == stdin)
return FLAC__STREAM_DECODER_TELL_STATUS_UNSUPPORTED;
else if((pos = ftello(file)) < 0)
return FLAC__STREAM_DECODER_TELL_STATUS_ERROR;
else {
*absolute_byte_offset = (FLAC__uint64)pos;
return FLAC__STREAM_DECODER_TELL_STATUS_OK;
}
}
FLAC__StreamDecoderTellStatus
FLAC__StreamDecoderTellStatus
Definition: stream_decoder.h:348
FLAC__STREAM_DECODER_TELL_STATUS_OK
@ FLAC__STREAM_DECODER_TELL_STATUS_OK
Definition: stream_decoder.h:350
FLAC__STREAM_DECODER_TELL_STATUS_ERROR
@ FLAC__STREAM_DECODER_TELL_STATUS_ERROR
Definition: stream_decoder.h:353
FLAC__STREAM_DECODER_TELL_STATUS_UNSUPPORTED
@ FLAC__STREAM_DECODER_TELL_STATUS_UNSUPPORTED
Definition: stream_decoder.h:356

Note
  In general, FLAC__StreamDecoder functions which change the state should not be called on the decoder while in the callback.

Parameters

  decoder | The decoder instance calling the callback.
  absolute_byte_offset | A pointer to storage for the current offset from the beginning of the stream.
  client_data | The callee's client data set through FLAC__stream_decoder_init_*().

Return values

  FLAC__StreamDecoderTellStatus | The callee's return status.

## ◆ FLAC__StreamDecoderLengthCallback

typedef FLAC__StreamDecoderLengthStatus(* FLAC__StreamDecoderLengthCallback) (const FLAC__StreamDecoder *decoder, FLAC__uint64 *stream_length, void *client_data)

Signature for the length callback.

A function pointer matching this signature may be passed to FLAC__stream_decoder_init*_stream(). The supplied function will be called when the decoder wants to know the total length of the stream in bytes.

Here is an example of a length callback for stdio streams:

FLAC__StreamDecoderLengthStatus length_cb(const FLAC__StreamDecoder *decoder, FLAC__uint64 *stream_length, void *client_data)
{
FILE *file = ((MyClientData*)client_data)->file;
struct stat filestats;
if(file == stdin)
return FLAC__STREAM_DECODER_LENGTH_STATUS_UNSUPPORTED;
else if(fstat(fileno(file), &filestats) != 0)
return FLAC__STREAM_DECODER_LENGTH_STATUS_ERROR;
else {
*stream_length = (FLAC__uint64)filestats.st_size;
return FLAC__STREAM_DECODER_LENGTH_STATUS_OK;
}
}
FLAC__StreamDecoderLengthStatus
FLAC__StreamDecoderLengthStatus
Definition: stream_decoder.h:371
FLAC__STREAM_DECODER_LENGTH_STATUS_ERROR
@ FLAC__STREAM_DECODER_LENGTH_STATUS_ERROR
Definition: stream_decoder.h:376
FLAC__STREAM_DECODER_LENGTH_STATUS_UNSUPPORTED
@ FLAC__STREAM_DECODER_LENGTH_STATUS_UNSUPPORTED
Definition: stream_decoder.h:379
FLAC__STREAM_DECODER_LENGTH_STATUS_OK
@ FLAC__STREAM_DECODER_LENGTH_STATUS_OK
Definition: stream_decoder.h:373

Note
  In general, FLAC__StreamDecoder functions which change the state should not be called on the decoder while in the callback.

Parameters

  decoder | The decoder instance calling the callback.
  stream_length | A pointer to storage for the length of the stream in bytes.
  client_data | The callee's client data set through FLAC__stream_decoder_init_*().

Return values

  FLAC__StreamDecoderLengthStatus | The callee's return status.

## ◆ FLAC__StreamDecoderEofCallback

typedef FLAC__bool(* FLAC__StreamDecoderEofCallback) (const FLAC__StreamDecoder *decoder, void *client_data)

Signature for the EOF callback.

A function pointer matching this signature may be passed to FLAC__stream_decoder_init*_stream(). The supplied function will be called when the decoder needs to know if the end of the stream has been reached.

Here is an example of a EOF callback for stdio streams: FLAC__bool eof_cb(const FLAC__StreamDecoder *decoder, void *client_data)

{
FILE *file = ((MyClientData*)client_data)->file;
return feof(file)? true : false;
}

Note
  In general, FLAC__StreamDecoder functions which change the state should not be called on the decoder while in the callback.

Parameters

  decoder | The decoder instance calling the callback.
  client_data | The callee's client data set through FLAC__stream_decoder_init_*().

Return values

  FLAC__bool | `true` if the currently at the end of the stream, else `false`.

## ◆ FLAC__StreamDecoderWriteCallback

typedef FLAC__StreamDecoderWriteStatus(* FLAC__StreamDecoderWriteCallback) (const FLAC__StreamDecoder *decoder, const FLAC__Frame *frame, const FLAC__int32 *const buffer[], void *client_data)

Signature for the write callback.

A function pointer matching this signature must be passed to one of the FLAC__stream_decoder_init_*() functions. The supplied function will be called when the decoder has decoded a single audio frame. The decoder will pass the frame metadata as well as an array of pointers (one for each channel) pointing to the decoded audio.

Note
  In general, FLAC__StreamDecoder functions which change the state should not be called on the decoder while in the callback.

Parameters

  decoder | The decoder instance calling the callback.
  frame | The description of the decoded frame. See FLAC__Frame.
  buffer | An array of pointers to decoded channels of data. Each pointer will point to an array of signed samples of length frame->header.blocksize. Channels will be ordered according to the FLAC specification; see the documentation for the frame header.
  client_data | The callee's client data set through FLAC__stream_decoder_init_*().

Return values

  FLAC__StreamDecoderWriteStatus | The callee's return status.

## ◆ FLAC__StreamDecoderMetadataCallback

typedef void(* FLAC__StreamDecoderMetadataCallback) (const FLAC__StreamDecoder *decoder, const FLAC__StreamMetadata *metadata, void *client_data)

Signature for the metadata callback.

A function pointer matching this signature must be passed to one of the FLAC__stream_decoder_init_*() functions. The supplied function will be called when the decoder has decoded a metadata block. In a valid FLAC file there will always be one `STREAMINFO` block, followed by zero or more other metadata blocks. These will be supplied by the decoder in the same order as they appear in the stream and always before the first audio frame (i.e. write callback). The metadata block that is passed in must not be modified, and it doesn't live beyond the callback, so you should make a copy of it with FLAC__metadata_object_clone() if you will need it elsewhere. Since metadata blocks can potentially be large, by default the decoder only calls the metadata callback for the `STREAMINFO` block; you can instruct the decoder to pass or filter other blocks with FLAC__stream_decoder_set_metadata_*() calls.

Note
  In general, FLAC__StreamDecoder functions which change the state should not be called on the decoder while in the callback.

Parameters

  decoder | The decoder instance calling the callback.
  metadata | The decoded metadata block.
  client_data | The callee's client data set through FLAC__stream_decoder_init_*().

## ◆ FLAC__StreamDecoderErrorCallback

typedef void(* FLAC__StreamDecoderErrorCallback) (const FLAC__StreamDecoder *decoder, FLAC__StreamDecoderErrorStatus status, void *client_data)

Signature for the error callback.

A function pointer matching this signature must be passed to one of the FLAC__stream_decoder_init_*() functions. The supplied function will be called whenever an error occurs during decoding.

Note
  In general, FLAC__StreamDecoder functions which change the state should not be called on the decoder while in the callback.

Parameters

  decoder | The decoder instance calling the callback.
  status | The error encountered by the decoder.
  client_data | The callee's client data set through FLAC__stream_decoder_init_*().

## Enumeration Type Documentation

## ◆ FLAC__StreamDecoderState

enum FLAC__StreamDecoderState

State values for a FLAC__StreamDecoder

The decoder's state can be obtained by calling FLAC__stream_decoder_get_state().

Enumerator
FLAC__STREAM_DECODER_SEARCH_FOR_METADATA | The decoder is ready to search for metadata.
FLAC__STREAM_DECODER_READ_METADATA | The decoder is ready to or is in the process of reading metadata.
FLAC__STREAM_DECODER_SEARCH_FOR_FRAME_SYNC | The decoder is ready to or is in the process of searching for the frame sync code.
FLAC__STREAM_DECODER_READ_FRAME | The decoder is ready to or is in the process of reading a frame.
FLAC__STREAM_DECODER_END_OF_STREAM | The decoder has reached the end of the stream.
FLAC__STREAM_DECODER_OGG_ERROR | An error occurred in the underlying Ogg layer.
FLAC__STREAM_DECODER_SEEK_ERROR | An error occurred while seeking. The decoder must be flushed with FLAC__stream_decoder_flush() or reset with FLAC__stream_decoder_reset() before decoding can continue.
FLAC__STREAM_DECODER_ABORTED | The decoder was aborted by the read or write callback.
FLAC__STREAM_DECODER_MEMORY_ALLOCATION_ERROR | An error occurred allocating memory. The decoder is in an invalid state and can no longer be used.
FLAC__STREAM_DECODER_UNINITIALIZED | The decoder is in the uninitialized state; one of the FLAC__stream_decoder_init_*() functions must be called before samples can be processed.

## ◆ FLAC__StreamDecoderInitStatus

enum FLAC__StreamDecoderInitStatus

Possible return values for the FLAC__stream_decoder_init_*() functions.

Enumerator
FLAC__STREAM_DECODER_INIT_STATUS_OK | Initialization was successful.
FLAC__STREAM_DECODER_INIT_STATUS_UNSUPPORTED_CONTAINER | The library was not compiled with support for the given container format.
FLAC__STREAM_DECODER_INIT_STATUS_INVALID_CALLBACKS | A required callback was not supplied.
FLAC__STREAM_DECODER_INIT_STATUS_MEMORY_ALLOCATION_ERROR | An error occurred allocating memory.
FLAC__STREAM_DECODER_INIT_STATUS_ERROR_OPENING_FILE | fopen() failed in FLAC__stream_decoder_init_file() or FLAC__stream_decoder_init_ogg_file().
FLAC__STREAM_DECODER_INIT_STATUS_ALREADY_INITIALIZED | FLAC__stream_decoder_init_*() was called when the decoder was already initialized, usually because FLAC__stream_decoder_finish() was not called.

## ◆ FLAC__StreamDecoderReadStatus

enum FLAC__StreamDecoderReadStatus

Return values for the FLAC__StreamDecoder read callback.

Enumerator
FLAC__STREAM_DECODER_READ_STATUS_CONTINUE | The read was OK and decoding can continue.
FLAC__STREAM_DECODER_READ_STATUS_END_OF_STREAM | The read was attempted while at the end of the stream. Note that the client must only return this value when the read callback was called when already at the end of the stream. Otherwise, if the read itself moves to the end of the stream, the client should still return the data and `FLAC__STREAM_DECODER_READ_STATUS_CONTINUE`, and then on the next read callback it should return `FLAC__STREAM_DECODER_READ_STATUS_END_OF_STREAM` with a byte count of `0`.
FLAC__STREAM_DECODER_READ_STATUS_ABORT | An unrecoverable error occurred. The decoder will return from the process call.

## ◆ FLAC__StreamDecoderSeekStatus

enum FLAC__StreamDecoderSeekStatus

Return values for the FLAC__StreamDecoder seek callback.

Enumerator
FLAC__STREAM_DECODER_SEEK_STATUS_OK | The seek was OK and decoding can continue.
FLAC__STREAM_DECODER_SEEK_STATUS_ERROR | An unrecoverable error occurred. The decoder will return from the process call.
FLAC__STREAM_DECODER_SEEK_STATUS_UNSUPPORTED | Client does not support seeking.

## ◆ FLAC__StreamDecoderTellStatus

enum FLAC__StreamDecoderTellStatus

Return values for the FLAC__StreamDecoder tell callback.

Enumerator
FLAC__STREAM_DECODER_TELL_STATUS_OK | The tell was OK and decoding can continue.
FLAC__STREAM_DECODER_TELL_STATUS_ERROR | An unrecoverable error occurred. The decoder will return from the process call.
FLAC__STREAM_DECODER_TELL_STATUS_UNSUPPORTED | Client does not support telling the position.

## ◆ FLAC__StreamDecoderLengthStatus

enum FLAC__StreamDecoderLengthStatus

Return values for the FLAC__StreamDecoder length callback.

Enumerator
FLAC__STREAM_DECODER_LENGTH_STATUS_OK | The length call was OK and decoding can continue.
FLAC__STREAM_DECODER_LENGTH_STATUS_ERROR | An unrecoverable error occurred. The decoder will return from the process call.
FLAC__STREAM_DECODER_LENGTH_STATUS_UNSUPPORTED | Client does not support reporting the length.

## ◆ FLAC__StreamDecoderWriteStatus

enum FLAC__StreamDecoderWriteStatus

Return values for the FLAC__StreamDecoder write callback.

Enumerator
FLAC__STREAM_DECODER_WRITE_STATUS_CONTINUE | The write was OK and decoding can continue.
FLAC__STREAM_DECODER_WRITE_STATUS_ABORT | An unrecoverable error occurred. The decoder will return from the process call.

## ◆ FLAC__StreamDecoderErrorStatus

enum FLAC__StreamDecoderErrorStatus

Possible values passed back to the FLAC__StreamDecoder error callback. `FLAC__STREAM_DECODER_ERROR_STATUS_LOST_SYNC` is the generic catch- all. The rest could be caused by bad sync (false synchronization on data that is not the start of a frame) or corrupted data. The error itself is the decoder's best guess at what happened assuming a correct sync. For example `FLAC__STREAM_DECODER_ERROR_STATUS_BAD_HEADER` could be caused by a correct sync on the start of a frame, but some data in the frame header was corrupted. Or it could be the result of syncing on a point the stream that looked like the starting of a frame but was not. `FLAC__STREAM_DECODER_ERROR_STATUS_UNPARSEABLE_STREAM` could be because the decoder encountered a valid frame made by a future version of the encoder which it cannot parse, or because of a false sync making it appear as though an encountered frame was generated by a future encoder. `FLAC__STREAM_DECODER_ERROR_STATUS_BAD_METADATA` is caused by finding data that doesn't fit a metadata block (too large or too small) or finding inconsistencies in the metadata, for example a PICTURE block with an image that exceeds the size of the metadata block.

Enumerator
FLAC__STREAM_DECODER_ERROR_STATUS_LOST_SYNC | An error in the stream caused the decoder to lose synchronization.
FLAC__STREAM_DECODER_ERROR_STATUS_BAD_HEADER | The decoder encountered a corrupted frame header.
FLAC__STREAM_DECODER_ERROR_STATUS_FRAME_CRC_MISMATCH | The frame's data did not match the CRC in the footer.
FLAC__STREAM_DECODER_ERROR_STATUS_UNPARSEABLE_STREAM | The decoder encountered reserved fields in use in the stream.
FLAC__STREAM_DECODER_ERROR_STATUS_BAD_METADATA | The decoder encountered a corrupted metadata block.

## Function Documentation

## ◆ FLAC__stream_decoder_new()

FLAC__StreamDecoder * FLAC__stream_decoder_new | ( | void |  | ) |

Create a new stream decoder instance. The instance is created with default settings; see the individual FLAC__stream_decoder_set_*() functions for each setting's default.

Return values

  FLAC__StreamDecoder* | `NULL` if there was an error allocating memory, else the new instance.

## ◆ FLAC__stream_decoder_delete()

void FLAC__stream_decoder_delete | ( | FLAC__StreamDecoder * | decoder | ) |

Free a decoder instance. Deletes the object pointed to by decoder.

Parameters

  decoder | A pointer to an existing decoder.

Assertions:
  decoder != NULL

## ◆ FLAC__stream_decoder_set_ogg_serial_number()

FLAC__bool FLAC__stream_decoder_set_ogg_serial_number | ( | FLAC__StreamDecoder * | decoder,
|  | long | serial_number
| ) |  |

Set the serial number for the FLAC stream within the Ogg container. The default behavior is to use the serial number of the first Ogg page. Setting a serial number here will explicitly specify which stream is to be decoded.

Note
  This does not need to be set for native FLAC decoding.

Default Value: `use` serial number of first page

Parameters

  decoder | A decoder instance to set.
  serial_number | See above.

Assertions:
  decoder != NULL

Return values

  FLAC__bool | `false` if the decoder is already initialized, else `true`.

## ◆ FLAC__stream_decoder_set_md5_checking()

FLAC__bool FLAC__stream_decoder_set_md5_checking | ( | FLAC__StreamDecoder * | decoder,
|  | FLAC__bool | value
| ) |  |

Set the "MD5 signature checking" flag. If `true`, the decoder will compute the MD5 signature of the unencoded audio data while decoding and compare it to the signature from the STREAMINFO block, if it exists, during FLAC__stream_decoder_finish().

MD5 signature checking will be turned off (until the next FLAC__stream_decoder_reset()) if there is no signature in the STREAMINFO block or when a seek is attempted.

Clients that do not use the MD5 check should leave this off to speed up decoding.

Default Value: `false`

Parameters

  decoder | A decoder instance to set.
  value | Flag value (see above).

Assertions:
  decoder != NULL

Return values

  FLAC__bool | `false` if the decoder is already initialized, else `true`.

## ◆ FLAC__stream_decoder_set_metadata_respond()

FLAC__bool FLAC__stream_decoder_set_metadata_respond | ( | FLAC__StreamDecoder * | decoder,
|  | FLAC__MetadataType | type
| ) |  |

Direct the decoder to pass on all metadata blocks of type type.

Default Value: By default, only the `STREAMINFO` block is returned via the
  metadata callback.

Parameters

  decoder | A decoder instance to set.
  type | See above.

Assertions:
  decoder != NULL
  type is valid

Return values

  FLAC__bool | `false` if the decoder is already initialized, else `true`.

## ◆ FLAC__stream_decoder_set_metadata_respond_application()

FLAC__bool FLAC__stream_decoder_set_metadata_respond_application | ( | FLAC__StreamDecoder * | decoder,
|  | const FLAC__byte | id[4]
| ) |  |

Direct the decoder to pass on all APPLICATION metadata blocks of the given id.

Default Value: By default, only the `STREAMINFO` block is returned via the
  metadata callback.

Parameters

  decoder | A decoder instance to set.
  id | See above.

Assertions:
  decoder != NULL
  id != NULL

Return values

  FLAC__bool | `false` if the decoder is already initialized, else `true`.

## ◆ FLAC__stream_decoder_set_metadata_respond_all()

FLAC__bool FLAC__stream_decoder_set_metadata_respond_all | ( | FLAC__StreamDecoder * | decoder | ) |

Direct the decoder to pass on all metadata blocks of any type.

Default Value: By default, only the `STREAMINFO` block is returned via the
  metadata callback.

Parameters

  decoder | A decoder instance to set.

Assertions:
  decoder != NULL

Return values

  FLAC__bool | `false` if the decoder is already initialized, else `true`.

## ◆ FLAC__stream_decoder_set_metadata_ignore()

FLAC__bool FLAC__stream_decoder_set_metadata_ignore | ( | FLAC__StreamDecoder * | decoder,
|  | FLAC__MetadataType | type
| ) |  |

Direct the decoder to filter out all metadata blocks of type type.

Default Value: By default, only the `STREAMINFO` block is returned via the
  metadata callback.

Parameters

  decoder | A decoder instance to set.
  type | See above.

Assertions:
  decoder != NULL
  type is valid

Return values

  FLAC__bool | `false` if the decoder is already initialized, else `true`.

## ◆ FLAC__stream_decoder_set_metadata_ignore_application()

FLAC__bool FLAC__stream_decoder_set_metadata_ignore_application | ( | FLAC__StreamDecoder * | decoder,
|  | const FLAC__byte | id[4]
| ) |  |

Direct the decoder to filter out all APPLICATION metadata blocks of the given id.

Default Value: By default, only the `STREAMINFO` block is returned via the
  metadata callback.

Parameters

  decoder | A decoder instance to set.
  id | See above.

Assertions:
  decoder != NULL
  id != NULL

Return values

  FLAC__bool | `false` if the decoder is already initialized, else `true`.

## ◆ FLAC__stream_decoder_set_metadata_ignore_all()

FLAC__bool FLAC__stream_decoder_set_metadata_ignore_all | ( | FLAC__StreamDecoder * | decoder | ) |

Direct the decoder to filter out all metadata blocks of any type.

Default Value: By default, only the `STREAMINFO` block is returned via the
  metadata callback.

Parameters

  decoder | A decoder instance to set.

Assertions:
  decoder != NULL

Return values

  FLAC__bool | `false` if the decoder is already initialized, else `true`.

## ◆ FLAC__stream_decoder_get_state()

FLAC__StreamDecoderState FLAC__stream_decoder_get_state | ( | const FLAC__StreamDecoder * | decoder | ) |

Get the current decoder state.

Parameters

  decoder | A decoder instance to query.

Assertions:
  decoder != NULL

Return values

  FLAC__StreamDecoderState | The current decoder state.

## ◆ FLAC__stream_decoder_get_resolved_state_string()

const char * FLAC__stream_decoder_get_resolved_state_string | ( | const FLAC__StreamDecoder * | decoder | ) |

Get the current decoder state as a C string.

Parameters

  decoder | A decoder instance to query.

Assertions:
  decoder != NULL

Return values

  const | char * The decoder state as a C string. Do not modify the contents.

## ◆ FLAC__stream_decoder_get_md5_checking()

FLAC__bool FLAC__stream_decoder_get_md5_checking | ( | const FLAC__StreamDecoder * | decoder | ) |

Get the "MD5 signature checking" flag. This is the value of the setting, not whether or not the decoder is currently checking the MD5 (remember, it can be turned off automatically by a seek). When the decoder is reset the flag will be restored to the value returned by this function.

Parameters

  decoder | A decoder instance to query.

Assertions:
  decoder != NULL

Return values

  FLAC__bool | See above.

## ◆ FLAC__stream_decoder_get_total_samples()

FLAC__uint64 FLAC__stream_decoder_get_total_samples | ( | const FLAC__StreamDecoder * | decoder | ) |

Get the total number of samples in the stream being decoded. Will only be valid after decoding has started and will contain the value from the `STREAMINFO` block. A value of `0` means "unknown".

Parameters

  decoder | A decoder instance to query.

Assertions:
  decoder != NULL

Return values

  uint32_t | See above.

## ◆ FLAC__stream_decoder_get_channels()

uint32_t FLAC__stream_decoder_get_channels | ( | const FLAC__StreamDecoder * | decoder | ) |

Get the current number of channels in the stream being decoded. Will only be valid after decoding has started and will contain the value from the most recently decoded frame header.

Parameters

  decoder | A decoder instance to query.

Assertions:
  decoder != NULL

Return values

  uint32_t | See above.

## ◆ FLAC__stream_decoder_get_channel_assignment()

FLAC__ChannelAssignment FLAC__stream_decoder_get_channel_assignment | ( | const FLAC__StreamDecoder * | decoder | ) |

Get the current channel assignment in the stream being decoded. Will only be valid after decoding has started and will contain the value from the most recently decoded frame header.

Parameters

  decoder | A decoder instance to query.

Assertions:
  decoder != NULL

Return values

  FLAC__ChannelAssignment | See above.

## ◆ FLAC__stream_decoder_get_bits_per_sample()

uint32_t FLAC__stream_decoder_get_bits_per_sample | ( | const FLAC__StreamDecoder * | decoder | ) |

Get the current sample resolution in the stream being decoded. Will only be valid after decoding has started and will contain the value from the most recently decoded frame header.

Parameters

  decoder | A decoder instance to query.

Assertions:
  decoder != NULL

Return values

  uint32_t | See above.

## ◆ FLAC__stream_decoder_get_sample_rate()

uint32_t FLAC__stream_decoder_get_sample_rate | ( | const FLAC__StreamDecoder * | decoder | ) |

Get the current sample rate in Hz of the stream being decoded. Will only be valid after decoding has started and will contain the value from the most recently decoded frame header.

Parameters

  decoder | A decoder instance to query.

Assertions:
  decoder != NULL

Return values

  uint32_t | See above.

## ◆ FLAC__stream_decoder_get_blocksize()

uint32_t FLAC__stream_decoder_get_blocksize | ( | const FLAC__StreamDecoder * | decoder | ) |

Get the current blocksize of the stream being decoded. Will only be valid after decoding has started and will contain the value from the most recently decoded frame header.

Parameters

  decoder | A decoder instance to query.

Assertions:
  decoder != NULL

Return values

  uint32_t | See above.

## ◆ FLAC__stream_decoder_get_decode_position()

FLAC__bool FLAC__stream_decoder_get_decode_position | ( | const FLAC__StreamDecoder * | decoder,
|  | FLAC__uint64 * | position
| ) |  |

Returns the decoder's current read position within the stream. The position is the byte offset from the start of the stream. Bytes before this position have been fully decoded. Note that there may still be undecoded bytes in the decoder's read FIFO. The returned position is correct even after a seek.

Warning
  This function currently only works for native FLAC, not Ogg FLAC streams.

Parameters

  decoder | A decoder instance to query.
  position | Address at which to return the desired position.

Assertions:
  decoder != NULL
  position != NULL

Return values

  FLAC__bool | `true` if successful, `false` if the stream is not native FLAC, or there was an error from the 'tell' callback or it returned `FLAC__STREAM_DECODER_TELL_STATUS_UNSUPPORTED`.

## ◆ FLAC__stream_decoder_get_client_data()

const void * FLAC__stream_decoder_get_client_data | ( | FLAC__StreamDecoder * | decoder | ) |

Return client_data from decoder. The data pointed to by the pointer should not be modified.

Parameters

  decoder | A decoder instance.

Return values

  const | void * The callee's client data set through FLAC__stream_decoder_init_*(). Do not modify the contents.

## ◆ FLAC__stream_decoder_init_stream()

FLAC__StreamDecoderInitStatus FLAC__stream_decoder_init_stream | ( | FLAC__StreamDecoder * | decoder,
|  | FLAC__StreamDecoderReadCallback | read_callback,
|  | FLAC__StreamDecoderSeekCallback | seek_callback,
|  | FLAC__StreamDecoderTellCallback | tell_callback,
|  | FLAC__StreamDecoderLengthCallback | length_callback,
|  | FLAC__StreamDecoderEofCallback | eof_callback,
|  | FLAC__StreamDecoderWriteCallback | write_callback,
|  | FLAC__StreamDecoderMetadataCallback | metadata_callback,
|  | FLAC__StreamDecoderErrorCallback | error_callback,
|  | void * | client_data
| ) |  |

Initialize the decoder instance to decode native FLAC streams.

This flavor of initialization sets up the decoder to decode from a native FLAC stream. I/O is performed via callbacks to the client. For decoding from a plain file via filename or open FILE*, FLAC__stream_decoder_init_file() and FLAC__stream_decoder_init_FILE() provide a simpler interface.

This function should be called after FLAC__stream_decoder_new() and FLAC__stream_decoder_set_*() but before any of the FLAC__stream_decoder_process_*() functions. Will set and return the decoder state, which will be FLAC__STREAM_DECODER_SEARCH_FOR_METADATA if initialization succeeded.

Parameters

  decoder | An uninitialized decoder instance.
  read_callback | See FLAC__StreamDecoderReadCallback. This pointer must not be `NULL`.
  seek_callback | See FLAC__StreamDecoderSeekCallback. This pointer may be `NULL` if seeking is not supported. If seek_callback is not `NULL` then a tell_callback, length_callback, and eof_callback must also be supplied. Alternatively, a dummy seek callback that just returns `FLAC__STREAM_DECODER_SEEK_STATUS_UNSUPPORTED` may also be supplied, all though this is slightly less efficient for the decoder.
  tell_callback | See FLAC__StreamDecoderTellCallback. This pointer may be `NULL` if not supported by the client. If seek_callback is not `NULL` then a tell_callback must also be supplied. Alternatively, a dummy tell callback that just returns `FLAC__STREAM_DECODER_TELL_STATUS_UNSUPPORTED` may also be supplied, all though this is slightly less efficient for the decoder.
  length_callback | See FLAC__StreamDecoderLengthCallback. This pointer may be `NULL` if not supported by the client. If seek_callback is not `NULL` then a length_callback must also be supplied. Alternatively, a dummy length callback that just returns `FLAC__STREAM_DECODER_LENGTH_STATUS_UNSUPPORTED` may also be supplied, all though this is slightly less efficient for the decoder.
  eof_callback | See FLAC__StreamDecoderEofCallback. This pointer may be `NULL` if not supported by the client. If seek_callback is not `NULL` then a eof_callback must also be supplied. Alternatively, a dummy length callback that just returns `false` may also be supplied, all though this is slightly less efficient for the decoder.
  write_callback | See FLAC__StreamDecoderWriteCallback. This pointer must not be `NULL`.
  metadata_callback | See FLAC__StreamDecoderMetadataCallback. This pointer may be `NULL` if the callback is not desired.
  error_callback | See FLAC__StreamDecoderErrorCallback. This pointer must not be `NULL`.
  client_data | This value will be supplied to callbacks in their client_data argument.

Assertions:
  decoder != NULL

Return values

  FLAC__StreamDecoderInitStatus | `FLAC__STREAM_DECODER_INIT_STATUS_OK` if initialization was successful; see FLAC__StreamDecoderInitStatus for the meanings of other return values.

## ◆ FLAC__stream_decoder_init_ogg_stream()

FLAC__StreamDecoderInitStatus FLAC__stream_decoder_init_ogg_stream | ( | FLAC__StreamDecoder * | decoder,
|  | FLAC__StreamDecoderReadCallback | read_callback,
|  | FLAC__StreamDecoderSeekCallback | seek_callback,
|  | FLAC__StreamDecoderTellCallback | tell_callback,
|  | FLAC__StreamDecoderLengthCallback | length_callback,
|  | FLAC__StreamDecoderEofCallback | eof_callback,
|  | FLAC__StreamDecoderWriteCallback | write_callback,
|  | FLAC__StreamDecoderMetadataCallback | metadata_callback,
|  | FLAC__StreamDecoderErrorCallback | error_callback,
|  | void * | client_data
| ) |  |

Initialize the decoder instance to decode Ogg FLAC streams.

This flavor of initialization sets up the decoder to decode from a FLAC stream in an Ogg container. I/O is performed via callbacks to the client. For decoding from a plain file via filename or open FILE*, FLAC__stream_decoder_init_ogg_file() and FLAC__stream_decoder_init_ogg_FILE() provide a simpler interface.

This function should be called after FLAC__stream_decoder_new() and FLAC__stream_decoder_set_*() but before any of the FLAC__stream_decoder_process_*() functions. Will set and return the decoder state, which will be FLAC__STREAM_DECODER_SEARCH_FOR_METADATA if initialization succeeded.

Note
  Support for Ogg FLAC in the library is optional. If this library has been built without support for Ogg FLAC, this function will return `FLAC__STREAM_DECODER_INIT_STATUS_UNSUPPORTED_CONTAINER`.

Parameters

  decoder | An uninitialized decoder instance.
  read_callback | See FLAC__StreamDecoderReadCallback. This pointer must not be `NULL`.
  seek_callback | See FLAC__StreamDecoderSeekCallback. This pointer may be `NULL` if seeking is not supported. If seek_callback is not `NULL` then a tell_callback, length_callback, and eof_callback must also be supplied. Alternatively, a dummy seek callback that just returns `FLAC__STREAM_DECODER_SEEK_STATUS_UNSUPPORTED` may also be supplied, all though this is slightly less efficient for the decoder.
  tell_callback | See FLAC__StreamDecoderTellCallback. This pointer may be `NULL` if not supported by the client. If seek_callback is not `NULL` then a tell_callback must also be supplied. Alternatively, a dummy tell callback that just returns `FLAC__STREAM_DECODER_TELL_STATUS_UNSUPPORTED` may also be supplied, all though this is slightly less efficient for the decoder.
  length_callback | See FLAC__StreamDecoderLengthCallback. This pointer may be `NULL` if not supported by the client. If seek_callback is not `NULL` then a length_callback must also be supplied. Alternatively, a dummy length callback that just returns `FLAC__STREAM_DECODER_LENGTH_STATUS_UNSUPPORTED` may also be supplied, all though this is slightly less efficient for the decoder.
  eof_callback | See FLAC__StreamDecoderEofCallback. This pointer may be `NULL` if not supported by the client. If seek_callback is not `NULL` then a eof_callback must also be supplied. Alternatively, a dummy length callback that just returns `false` may also be supplied, all though this is slightly less efficient for the decoder.
  write_callback | See FLAC__StreamDecoderWriteCallback. This pointer must not be `NULL`.
  metadata_callback | See FLAC__StreamDecoderMetadataCallback. This pointer may be `NULL` if the callback is not desired.
  error_callback | See FLAC__StreamDecoderErrorCallback. This pointer must not be `NULL`.
  client_data | This value will be supplied to callbacks in their client_data argument.

Assertions:
  decoder != NULL

Return values

  FLAC__StreamDecoderInitStatus | `FLAC__STREAM_DECODER_INIT_STATUS_OK` if initialization was successful; see FLAC__StreamDecoderInitStatus for the meanings of other return values.

## ◆ FLAC__stream_decoder_init_FILE()

FLAC__StreamDecoderInitStatus FLAC__stream_decoder_init_FILE | ( | FLAC__StreamDecoder * | decoder,
|  | FILE * | file,
|  | FLAC__StreamDecoderWriteCallback | write_callback,
|  | FLAC__StreamDecoderMetadataCallback | metadata_callback,
|  | FLAC__StreamDecoderErrorCallback | error_callback,
|  | void * | client_data
| ) |  |

Initialize the decoder instance to decode native FLAC files.

This flavor of initialization sets up the decoder to decode from a plain native FLAC file. For non-stdio streams, you must use FLAC__stream_decoder_init_stream() and provide callbacks for the I/O.

This function should be called after FLAC__stream_decoder_new() and FLAC__stream_decoder_set_*() but before any of the FLAC__stream_decoder_process_*() functions. Will set and return the decoder state, which will be FLAC__STREAM_DECODER_SEARCH_FOR_METADATA if initialization succeeded.

Parameters

  decoder | An uninitialized decoder instance.
  file | An open FLAC file. The file should have been opened with mode `"rb"` and rewound. The file becomes owned by the decoder and should not be manipulated by the client while decoding. Unless file is `stdin`, it will be closed when FLAC__stream_decoder_finish() is called. Note however that seeking will not work when decoding from `stdin` since it is not seekable.
  write_callback | See FLAC__StreamDecoderWriteCallback. This pointer must not be `NULL`.
  metadata_callback | See FLAC__StreamDecoderMetadataCallback. This pointer may be `NULL` if the callback is not desired.
  error_callback | See FLAC__StreamDecoderErrorCallback. This pointer must not be `NULL`.
  client_data | This value will be supplied to callbacks in their client_data argument.

Assertions:
  decoder != NULL
  file != NULL

Return values

  FLAC__StreamDecoderInitStatus | `FLAC__STREAM_DECODER_INIT_STATUS_OK` if initialization was successful; see FLAC__StreamDecoderInitStatus for the meanings of other return values.

## ◆ FLAC__stream_decoder_init_ogg_FILE()

FLAC__StreamDecoderInitStatus FLAC__stream_decoder_init_ogg_FILE | ( | FLAC__StreamDecoder * | decoder,
|  | FILE * | file,
|  | FLAC__StreamDecoderWriteCallback | write_callback,
|  | FLAC__StreamDecoderMetadataCallback | metadata_callback,
|  | FLAC__StreamDecoderErrorCallback | error_callback,
|  | void * | client_data
| ) |  |

Initialize the decoder instance to decode Ogg FLAC files.

This flavor of initialization sets up the decoder to decode from a plain Ogg FLAC file. For non-stdio streams, you must use FLAC__stream_decoder_init_ogg_stream() and provide callbacks for the I/O.

This function should be called after FLAC__stream_decoder_new() and FLAC__stream_decoder_set_*() but before any of the FLAC__stream_decoder_process_*() functions. Will set and return the decoder state, which will be FLAC__STREAM_DECODER_SEARCH_FOR_METADATA if initialization succeeded.

Note
  Support for Ogg FLAC in the library is optional. If this library has been built without support for Ogg FLAC, this function will return `FLAC__STREAM_DECODER_INIT_STATUS_UNSUPPORTED_CONTAINER`.

Parameters

  decoder | An uninitialized decoder instance.
  file | An open FLAC file. The file should have been opened with mode `"rb"` and rewound. The file becomes owned by the decoder and should not be manipulated by the client while decoding. Unless file is `stdin`, it will be closed when FLAC__stream_decoder_finish() is called. Note however that seeking will not work when decoding from `stdin` since it is not seekable.
  write_callback | See FLAC__StreamDecoderWriteCallback. This pointer must not be `NULL`.
  metadata_callback | See FLAC__StreamDecoderMetadataCallback. This pointer may be `NULL` if the callback is not desired.
  error_callback | See FLAC__StreamDecoderErrorCallback. This pointer must not be `NULL`.
  client_data | This value will be supplied to callbacks in their client_data argument.

Assertions:
  decoder != NULL
  file != NULL

Return values

  FLAC__StreamDecoderInitStatus | `FLAC__STREAM_DECODER_INIT_STATUS_OK` if initialization was successful; see FLAC__StreamDecoderInitStatus for the meanings of other return values.

## ◆ FLAC__stream_decoder_init_file()

FLAC__StreamDecoderInitStatus FLAC__stream_decoder_init_file | ( | FLAC__StreamDecoder * | decoder,
|  | const char * | filename,
|  | FLAC__StreamDecoderWriteCallback | write_callback,
|  | FLAC__StreamDecoderMetadataCallback | metadata_callback,
|  | FLAC__StreamDecoderErrorCallback | error_callback,
|  | void * | client_data
| ) |  |

Initialize the decoder instance to decode native FLAC files.

This flavor of initialization sets up the decoder to decode from a plain native FLAC file. If POSIX fopen() semantics are not sufficient, you must use FLAC__stream_decoder_init_FILE(), or FLAC__stream_decoder_init_stream() and provide callbacks for the I/O.

On Windows, filename must be a UTF-8 encoded filename, which libFLAC internally translates to an appropriate representation to use with _wfopen. On all other systems, filename is passed to fopen without any translation.

This function should be called after FLAC__stream_decoder_new() and FLAC__stream_decoder_set_*() but before any of the FLAC__stream_decoder_process_*() functions. Will set and return the decoder state, which will be FLAC__STREAM_DECODER_SEARCH_FOR_METADATA if initialization succeeded.

Parameters

  decoder | An uninitialized decoder instance.
  filename | The name of the file to decode from. The file will be opened with fopen(). Use `NULL` to decode from `stdin`. Note that `stdin` is not seekable.
  write_callback | See FLAC__StreamDecoderWriteCallback. This pointer must not be `NULL`.
  metadata_callback | See FLAC__StreamDecoderMetadataCallback. This pointer may be `NULL` if the callback is not desired.
  error_callback | See FLAC__StreamDecoderErrorCallback. This pointer must not be `NULL`.
  client_data | This value will be supplied to callbacks in their client_data argument.

Assertions:
  decoder != NULL

Return values

  FLAC__StreamDecoderInitStatus | `FLAC__STREAM_DECODER_INIT_STATUS_OK` if initialization was successful; see FLAC__StreamDecoderInitStatus for the meanings of other return values.

## ◆ FLAC__stream_decoder_init_ogg_file()

FLAC__StreamDecoderInitStatus FLAC__stream_decoder_init_ogg_file | ( | FLAC__StreamDecoder * | decoder,
|  | const char * | filename,
|  | FLAC__StreamDecoderWriteCallback | write_callback,
|  | FLAC__StreamDecoderMetadataCallback | metadata_callback,
|  | FLAC__StreamDecoderErrorCallback | error_callback,
|  | void * | client_data
| ) |  |

Initialize the decoder instance to decode Ogg FLAC files.

This flavor of initialization sets up the decoder to decode from a plain Ogg FLAC file. If POSIX fopen() semantics are not sufficient, you must use FLAC__stream_decoder_init_ogg_FILE(), or FLAC__stream_decoder_init_ogg_stream() and provide callbacks for the I/O.

On Windows, filename must be a UTF-8 encoded filename, which libFLAC internally translates to an appropriate representation to use with _wfopen. On all other systems, filename is passed to fopen without any translation.

This function should be called after FLAC__stream_decoder_new() and FLAC__stream_decoder_set_*() but before any of the FLAC__stream_decoder_process_*() functions. Will set and return the decoder state, which will be FLAC__STREAM_DECODER_SEARCH_FOR_METADATA if initialization succeeded.

Note
  Support for Ogg FLAC in the library is optional. If this library has been built without support for Ogg FLAC, this function will return `FLAC__STREAM_DECODER_INIT_STATUS_UNSUPPORTED_CONTAINER`.

Parameters

  decoder | An uninitialized decoder instance.
  filename | The name of the file to decode from. The file will be opened with fopen(). Use `NULL` to decode from `stdin`. Note that `stdin` is not seekable.
  write_callback | See FLAC__StreamDecoderWriteCallback. This pointer must not be `NULL`.
  metadata_callback | See FLAC__StreamDecoderMetadataCallback. This pointer may be `NULL` if the callback is not desired.
  error_callback | See FLAC__StreamDecoderErrorCallback. This pointer must not be `NULL`.
  client_data | This value will be supplied to callbacks in their client_data argument.

Assertions:
  decoder != NULL

Return values

  FLAC__StreamDecoderInitStatus | `FLAC__STREAM_DECODER_INIT_STATUS_OK` if initialization was successful; see FLAC__StreamDecoderInitStatus for the meanings of other return values.

## ◆ FLAC__stream_decoder_finish()

FLAC__bool FLAC__stream_decoder_finish | ( | FLAC__StreamDecoder * | decoder | ) |

Finish the decoding process. Flushes the decoding buffer, releases resources, resets the decoder settings to their defaults, and returns the decoder state to FLAC__STREAM_DECODER_UNINITIALIZED.

In the event of a prematurely-terminated decode, it is not strictly necessary to call this immediately before FLAC__stream_decoder_delete() but it is good practice to match every FLAC__stream_decoder_init_*() with a FLAC__stream_decoder_finish().

Parameters

  decoder | An uninitialized decoder instance.

Assertions:
  decoder != NULL

Return values

  FLAC__bool | `false` if MD5 checking is on AND a STREAMINFO block was available AND the MD5 signature in the STREAMINFO block was non-zero AND the signature does not match the one computed by the decoder; else `true`.

## ◆ FLAC__stream_decoder_flush()

FLAC__bool FLAC__stream_decoder_flush | ( | FLAC__StreamDecoder * | decoder | ) |

Flush the stream input. The decoder's input buffer will be cleared and the state set to `FLAC__STREAM_DECODER_SEARCH_FOR_FRAME_SYNC`. This will also turn off MD5 checking.

Parameters

  decoder | A decoder instance.

Assertions:
  decoder != NULL

Return values

  FLAC__bool | `true` if successful, else `false` if a memory allocation error occurs (in which case the state will be set to `FLAC__STREAM_DECODER_MEMORY_ALLOCATION_ERROR`).

## ◆ FLAC__stream_decoder_reset()

FLAC__bool FLAC__stream_decoder_reset | ( | FLAC__StreamDecoder * | decoder | ) |

Reset the decoding process. The decoder's input buffer will be cleared and the state set to `FLAC__STREAM_DECODER_SEARCH_FOR_METADATA`. This is similar to FLAC__stream_decoder_finish() except that the settings are preserved; there is no need to call FLAC__stream_decoder_init_*() before decoding again. MD5 checking will be restored to its original setting.

If the decoder is seekable, or was initialized with FLAC__stream_decoder_init*_FILE() or FLAC__stream_decoder_init*_file(), the decoder will also attempt to seek to the beginning of the file. If this rewind fails, this function will return `false`. It follows that FLAC__stream_decoder_reset() cannot be used when decoding from `stdin`.

If the decoder was initialized with FLAC__stream_encoder_init*_stream() and is not seekable (i.e. no seek callback was provided or the seek callback returns `FLAC__STREAM_DECODER_SEEK_STATUS_UNSUPPORTED`), it is the duty of the client to start feeding data from the beginning of the stream on the next FLAC__stream_decoder_process_*() call.

Parameters

  decoder | A decoder instance.

Assertions:
  decoder != NULL

Return values

  FLAC__bool | `true` if successful, else `false` if a memory allocation occurs (in which case the state will be set to `FLAC__STREAM_DECODER_MEMORY_ALLOCATION_ERROR`) or a seek error occurs (the state will be unchanged).

## ◆ FLAC__stream_decoder_process_single()

FLAC__bool FLAC__stream_decoder_process_single | ( | FLAC__StreamDecoder * | decoder | ) |

Decode one metadata block or audio frame. This version instructs the decoder to decode a either a single metadata block or a single frame and stop, unless the callbacks return a fatal error or the read callback returns `FLAC__STREAM_DECODER_READ_STATUS_END_OF_STREAM`.

As the decoder needs more input it will call the read callback. Depending on what was decoded, the metadata or write callback will be called with the decoded metadata block or audio frame.

Unless there is a fatal read error or end of stream, this function will return once one whole frame is decoded. In other words, if the stream is not synchronized or points to a corrupt frame header, the decoder will continue to try and resync until it gets to a valid frame, then decode one frame, then return. If the decoder points to a frame whose frame CRC in the frame footer does not match the computed frame CRC, this function will issue a FLAC__STREAM_DECODER_ERROR_STATUS_FRAME_CRC_MISMATCH error to the error callback, and return, having decoded one complete, although corrupt, frame. (Such corrupted frames are sent as silence of the correct length to the write callback.)

Parameters

  decoder | An initialized decoder instance.

Assertions:
  decoder != NULL

Return values

  FLAC__bool | `false` if any fatal read, write, or memory allocation error occurred (meaning decoding must stop), else `true`; for more information about the decoder, check the decoder state with FLAC__stream_decoder_get_state().

## ◆ FLAC__stream_decoder_process_until_end_of_metadata()

FLAC__bool FLAC__stream_decoder_process_until_end_of_metadata | ( | FLAC__StreamDecoder * | decoder | ) |

Decode until the end of the metadata. This version instructs the decoder to decode from the current position and continue until all the metadata has been read, or until the callbacks return a fatal error or the read callback returns `FLAC__STREAM_DECODER_READ_STATUS_END_OF_STREAM`.

As the decoder needs more input it will call the read callback. As each metadata block is decoded, the metadata callback will be called with the decoded metadata.

Parameters

  decoder | An initialized decoder instance.

Assertions:
  decoder != NULL

Return values

  FLAC__bool | `false` if any fatal read, write, or memory allocation error occurred (meaning decoding must stop), else `true`; for more information about the decoder, check the decoder state with FLAC__stream_decoder_get_state().

## ◆ FLAC__stream_decoder_process_until_end_of_stream()

FLAC__bool FLAC__stream_decoder_process_until_end_of_stream | ( | FLAC__StreamDecoder * | decoder | ) |

Decode until the end of the stream. This version instructs the decoder to decode from the current position and continue until the end of stream (the read callback returns `FLAC__STREAM_DECODER_READ_STATUS_END_OF_STREAM`), or until the callbacks return a fatal error.

As the decoder needs more input it will call the read callback. As each metadata block and frame is decoded, the metadata or write callback will be called with the decoded metadata or frame.

Parameters

  decoder | An initialized decoder instance.

Assertions:
  decoder != NULL

Return values

  FLAC__bool | `false` if any fatal read, write, or memory allocation error occurred (meaning decoding must stop), else `true`; for more information about the decoder, check the decoder state with FLAC__stream_decoder_get_state().

## ◆ FLAC__stream_decoder_skip_single_frame()

FLAC__bool FLAC__stream_decoder_skip_single_frame | ( | FLAC__StreamDecoder * | decoder | ) |

Skip one audio frame. This version instructs the decoder to 'skip' a single frame and stop, unless the callbacks return a fatal error or the read callback returns `FLAC__STREAM_DECODER_READ_STATUS_END_OF_STREAM`.

The decoding flow is the same as what occurs when FLAC__stream_decoder_process_single() is called to process an audio frame, except that this function does not decode the parsed data into PCM or call the write callback. The integrity of the frame is still checked the same way as in the other process functions.

This function will return once one whole frame is skipped, in the same way that FLAC__stream_decoder_process_single() will return once one whole frame is decoded.

This function can be used in more quickly determining FLAC frame boundaries when decoding of the actual data is not needed, for example when an application is separating a FLAC stream into frames for editing or storing in a container. To do this, the application can use FLAC__stream_decoder_skip_single_frame() to quickly advance to the next frame, then use FLAC__stream_decoder_get_decode_position() to find the new frame boundary.

This function should only be called when the stream has advanced past all the metadata, otherwise it will return `false`.

Parameters

  decoder | An initialized decoder instance not in a metadata state.

Assertions:
  decoder != NULL

Return values

  FLAC__bool | `false` if any fatal read, write, or memory allocation error occurred (meaning decoding must stop), or if the decoder is in the FLAC__STREAM_DECODER_SEARCH_FOR_METADATA or FLAC__STREAM_DECODER_READ_METADATA state, else `true`; for more information about the decoder, check the decoder state with FLAC__stream_decoder_get_state().

## ◆ FLAC__stream_decoder_seek_absolute()

FLAC__bool FLAC__stream_decoder_seek_absolute | ( | FLAC__StreamDecoder * | decoder,
|  | FLAC__uint64 | sample
| ) |  |

Flush the input and seek to an absolute sample. Decoding will resume at the given sample. Note that because of this, the next write callback may contain a partial block. The client must support seeking the input or this function will fail and return `false`. Furthermore, if the decoder state is `FLAC__STREAM_DECODER_SEEK_ERROR`, then the decoder must be flushed with FLAC__stream_decoder_flush() or reset with FLAC__stream_decoder_reset() before decoding can continue.

Parameters

  decoder | A decoder instance.
  sample | The target sample number to seek to.

Assertions:
  decoder != NULL

Return values

  FLAC__bool | `true` if successful, else `false`.

## Variable Documentation

## ◆ FLAC__StreamDecoderStateString

const char* const FLAC__StreamDecoderStateString[]
| extern

Maps a FLAC__StreamDecoderState to a C string.

Using a FLAC__StreamDecoderState as the index to this array will give the string equivalent. The contents should not be modified.

## ◆ FLAC__StreamDecoderInitStatusString

const char* const FLAC__StreamDecoderInitStatusString[]
| extern

Maps a FLAC__StreamDecoderInitStatus to a C string.

Using a FLAC__StreamDecoderInitStatus as the index to this array will give the string equivalent. The contents should not be modified.

## ◆ FLAC__StreamDecoderReadStatusString

const char* const FLAC__StreamDecoderReadStatusString[]
| extern

Maps a FLAC__StreamDecoderReadStatus to a C string.

Using a FLAC__StreamDecoderReadStatus as the index to this array will give the string equivalent. The contents should not be modified.

## ◆ FLAC__StreamDecoderSeekStatusString

const char* const FLAC__StreamDecoderSeekStatusString[]
| extern

Maps a FLAC__StreamDecoderSeekStatus to a C string.

Using a FLAC__StreamDecoderSeekStatus as the index to this array will give the string equivalent. The contents should not be modified.

## ◆ FLAC__StreamDecoderTellStatusString

const char* const FLAC__StreamDecoderTellStatusString[]
| extern

Maps a FLAC__StreamDecoderTellStatus to a C string.

Using a FLAC__StreamDecoderTellStatus as the index to this array will give the string equivalent. The contents should not be modified.

## ◆ FLAC__StreamDecoderLengthStatusString

const char* const FLAC__StreamDecoderLengthStatusString[]
| extern

Maps a FLAC__StreamDecoderLengthStatus to a C string.

Using a FLAC__StreamDecoderLengthStatus as the index to this array will give the string equivalent. The contents should not be modified.

## ◆ FLAC__StreamDecoderWriteStatusString

const char* const FLAC__StreamDecoderWriteStatusString[]
| extern

Maps a FLAC__StreamDecoderWriteStatus to a C string.

Using a FLAC__StreamDecoderWriteStatus as the index to this array will give the string equivalent. The contents should not be modified.

## ◆ FLAC__StreamDecoderErrorStatusString

const char* const FLAC__StreamDecoderErrorStatusString[]
| extern

Maps a FLAC__StreamDecoderErrorStatus to a C string.

Using a FLAC__StreamDecoderErrorStatus as the index to this array will give the string equivalent. The contents should not be modified.

Copyright (c) 2000-2009 Josh Coalson Copyright (c) 2011-2022 Xiph.Org Foundation